/* Automatically generated nanopb header */
/* Generated by nanopb-0.4.6 */

#ifndef PB_PROTO_FILES_BOOMLAMP_PB_H_INCLUDED
#define PB_PROTO_FILES_BOOMLAMP_PB_H_INCLUDED
#include <pb.h>

#if PB_PROTO_HEADER_VERSION != 40
#error Regenerate this file with the current version of nanopb generator.
#endif

/* Enum definitions */
typedef enum _BoomLampMessage_Type { 
    BoomLampMessage_Type_ACK = 0, 
    BoomLampMessage_Type_LIGHT = 1, 
    BoomLampMessage_Type_DIAG = 2 
} BoomLampMessage_Type;

typedef enum _DiagnosticMessage_Type { 
    DiagnosticMessage_Type_PING = 1, 
    DiagnosticMessage_Type_PONG = 2, 
    DiagnosticMessage_Type_SET_TIME = 3, 
    DiagnosticMessage_Type_OHAI = 4, 
    DiagnosticMessage_Type_RADIO = 5, 
    DiagnosticMessage_Type_REBOOT = 6 
} DiagnosticMessage_Type;

typedef enum _LightMessage_Type { 
    LightMessage_Type_EXPLICIT = 1, 
    LightMessage_Type_STORE_INDEX = 2, 
    LightMessage_Type_RECALL_INDEX = 3 
} LightMessage_Type;

/* Struct definitions */
typedef struct _ExplicitColour { 
    /* HSV colours in [0, 1] range. */
    float h; /* Hue */
    float s; /* Saturation */
    float v; /* Value */
} ExplicitColour;

typedef struct _RadioParams { 
    uint32_t signalBandwidth; /* range 7800 - 500000 */
    uint32_t spreadingFactor; /* range [6, 12] */
} RadioParams;

typedef struct _DiagnosticMessage { 
    DiagnosticMessage_Type type;
    uint32_t timestamp;
    bool has_radio;
    RadioParams radio;
} DiagnosticMessage;

typedef struct _LightMessage { 
    LightMessage_Type type;
    bool has_colourIndex;
    uint32_t colourIndex;
    bool has_colour;
    ExplicitColour colour;
} LightMessage;

typedef struct _BoomLampMessage { 
    BoomLampMessage_Type type;
    /* Message sequence number: */
    uint32_t seq;
    /* Recipient MAC address, if unicast: */
    bool has_dstMac;
    uint64_t dstMac;
    /* Sender MAC address: */
    uint64_t srcMac;
    bool has_light;
    LightMessage light;
    bool has_diag;
    DiagnosticMessage diag;
} BoomLampMessage;


/* Helper constants for enums */
#define _BoomLampMessage_Type_MIN BoomLampMessage_Type_ACK
#define _BoomLampMessage_Type_MAX BoomLampMessage_Type_DIAG
#define _BoomLampMessage_Type_ARRAYSIZE ((BoomLampMessage_Type)(BoomLampMessage_Type_DIAG+1))

#define _DiagnosticMessage_Type_MIN DiagnosticMessage_Type_PING
#define _DiagnosticMessage_Type_MAX DiagnosticMessage_Type_REBOOT
#define _DiagnosticMessage_Type_ARRAYSIZE ((DiagnosticMessage_Type)(DiagnosticMessage_Type_REBOOT+1))

#define _LightMessage_Type_MIN LightMessage_Type_EXPLICIT
#define _LightMessage_Type_MAX LightMessage_Type_RECALL_INDEX
#define _LightMessage_Type_ARRAYSIZE ((LightMessage_Type)(LightMessage_Type_RECALL_INDEX+1))


#ifdef __cplusplus
extern "C" {
#endif

/* Initializer values for message structs */
#define BoomLampMessage_init_default             {_BoomLampMessage_Type_MIN, 0, false, 0, 0, false, LightMessage_init_default, false, DiagnosticMessage_init_default}
#define DiagnosticMessage_init_default           {_DiagnosticMessage_Type_MIN, 0, false, RadioParams_init_default}
#define RadioParams_init_default                 {0, 0}
#define LightMessage_init_default                {_LightMessage_Type_MIN, false, 0, false, ExplicitColour_init_default}
#define ExplicitColour_init_default              {0, 0, 0}
#define BoomLampMessage_init_zero                {_BoomLampMessage_Type_MIN, 0, false, 0, 0, false, LightMessage_init_zero, false, DiagnosticMessage_init_zero}
#define DiagnosticMessage_init_zero              {_DiagnosticMessage_Type_MIN, 0, false, RadioParams_init_zero}
#define RadioParams_init_zero                    {0, 0}
#define LightMessage_init_zero                   {_LightMessage_Type_MIN, false, 0, false, ExplicitColour_init_zero}
#define ExplicitColour_init_zero                 {0, 0, 0}

/* Field tags (for use in manual encoding/decoding) */
#define ExplicitColour_h_tag                     1
#define ExplicitColour_s_tag                     2
#define ExplicitColour_v_tag                     3
#define RadioParams_signalBandwidth_tag          10
#define RadioParams_spreadingFactor_tag          11
#define DiagnosticMessage_type_tag               1
#define DiagnosticMessage_timestamp_tag          2
#define DiagnosticMessage_radio_tag              11
#define LightMessage_type_tag                    1
#define LightMessage_colourIndex_tag             10
#define LightMessage_colour_tag                  11
#define BoomLampMessage_type_tag                 1
#define BoomLampMessage_seq_tag                  2
#define BoomLampMessage_dstMac_tag               3
#define BoomLampMessage_srcMac_tag               4
#define BoomLampMessage_light_tag                10
#define BoomLampMessage_diag_tag                 11

/* Struct field encoding specification for nanopb */
#define BoomLampMessage_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, UENUM,    type,              1) \
X(a, STATIC,   REQUIRED, UINT32,   seq,               2) \
X(a, STATIC,   OPTIONAL, UINT64,   dstMac,            3) \
X(a, STATIC,   REQUIRED, UINT64,   srcMac,            4) \
X(a, STATIC,   OPTIONAL, MESSAGE,  light,            10) \
X(a, STATIC,   OPTIONAL, MESSAGE,  diag,             11)
#define BoomLampMessage_CALLBACK NULL
#define BoomLampMessage_DEFAULT NULL
#define BoomLampMessage_light_MSGTYPE LightMessage
#define BoomLampMessage_diag_MSGTYPE DiagnosticMessage

#define DiagnosticMessage_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, UENUM,    type,              1) \
X(a, STATIC,   REQUIRED, UINT32,   timestamp,         2) \
X(a, STATIC,   OPTIONAL, MESSAGE,  radio,            11)
#define DiagnosticMessage_CALLBACK NULL
#define DiagnosticMessage_DEFAULT (const pb_byte_t*)"\x08\x01\x00"
#define DiagnosticMessage_radio_MSGTYPE RadioParams

#define RadioParams_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, UINT32,   signalBandwidth,  10) \
X(a, STATIC,   REQUIRED, UINT32,   spreadingFactor,  11)
#define RadioParams_CALLBACK NULL
#define RadioParams_DEFAULT NULL

#define LightMessage_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, UENUM,    type,              1) \
X(a, STATIC,   OPTIONAL, UINT32,   colourIndex,      10) \
X(a, STATIC,   OPTIONAL, MESSAGE,  colour,           11)
#define LightMessage_CALLBACK NULL
#define LightMessage_DEFAULT (const pb_byte_t*)"\x08\x01\x00"
#define LightMessage_colour_MSGTYPE ExplicitColour

#define ExplicitColour_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, FLOAT,    h,                 1) \
X(a, STATIC,   REQUIRED, FLOAT,    s,                 2) \
X(a, STATIC,   REQUIRED, FLOAT,    v,                 3)
#define ExplicitColour_CALLBACK NULL
#define ExplicitColour_DEFAULT NULL

extern const pb_msgdesc_t BoomLampMessage_msg;
extern const pb_msgdesc_t DiagnosticMessage_msg;
extern const pb_msgdesc_t RadioParams_msg;
extern const pb_msgdesc_t LightMessage_msg;
extern const pb_msgdesc_t ExplicitColour_msg;

/* Defines for backwards compatibility with code written before nanopb-0.4.0 */
#define BoomLampMessage_fields &BoomLampMessage_msg
#define DiagnosticMessage_fields &DiagnosticMessage_msg
#define RadioParams_fields &RadioParams_msg
#define LightMessage_fields &LightMessage_msg
#define ExplicitColour_fields &ExplicitColour_msg

/* Maximum encoded size of messages (where known) */
#define BoomLampMessage_size                     81
#define DiagnosticMessage_size                   22
#define ExplicitColour_size                      15
#define LightMessage_size                        25
#define RadioParams_size                         12

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
